# VPUD Package for Genio Ubuntu

This repository maintains Ubuntu packages of VPUD for Genio Ubuntu.

## Branches

The purpose of each branch:

- `upstream/iot-yocto/main`: This branch strictly follows the updates from IoT Yocto's
  vpud prebuilt repository: https://gitlab.com/mediatek/aiot/rity/vpud
- `ubuntu/jammy`: Provides the "Debianization" package meta-data for creating Ubuntu packages
  that can be subsequently upload to lauchpad.net PPA (Personal Package Archives) for installation.

## Files and Directories

- `README.md`: This README file
- `debian/`: Stores all the debian control files for packaging.

## Build Instructions

General workflow invovles:

1. Fetch new binary updates to `upstream/iot-yocto/main`. It should be a fast-forward only update.

2. Tag the upstream version, such as:

  * `upstream/23.0` for official release
  * `upstream/23.0.dev<date>` for development updates. Note that Debian versioning relies on
    alphanumerical sort, so "23.0.dev0" is NEWER than "23.0".

3. Checkout to `ubuntu/jammy` branch, and merge the upstream tag.

4. Update debian control files if necesssary, and update the changelog. 
   You can use `dch -i` to create a new entry template. 
   Remember to update the package version string and set `UNRELEASE` to
   `jammy` if the package has been tested. 

To build Ubuntu source packages, use `gbp`:

```
$ rm debian/files
$ gbp buildpackage -S -us -uc
$ cd ..
$ debsign -S *.changes
$ dput <ppa> *.changes
```

Note that you must setup GPG key according to launchpad.net instructions
for `debsign` and `dput` to work.